%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     ṹʱ̷Ĳַ                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc, clear, close all

dir = 'data_Reference';
newdir =['mkdir ' dir];
system(newdir);

%% ṹģ
% Mass
m1 = 40000;
m2 = 40000;
m = diag([m1,m2]);

% Stiffness
Lcol = 3.6;
Es=2e+11;
Ix=199327500e-12;
k_col = 12*Es*Ix/power(Lcol,3);
k = [4*k_col, -2*k_col; -2*k_col, 2*k_col];
KN = [3*k_col, -2*k_col; -2*k_col, 2*k_col];
kE = 2*k_col;  % 3*Es*Ix/power(Lcol/2,3);

% Damping
dpksi1 = 0.03;
dpksi2 = 0.03;
IMK = inv(m)*k;
E = eig(IMK);
W = sqrt(E);
omega = sort(W);
omega1 = omega(1);
omega2 = omega(2);
alpha = 2*omega1*omega2*(dpksi2*omega1-dpksi1*omega2)/(omega1*omega1-omega2*omega2);
beita = 2*(dpksi1*omega1-dpksi2*omega2)/(omega1*omega1-omega2*omega2);
c = alpha*m+beita*k;
cE = 0;

% Ground Motion
GM=load('ELC180_0.005_50s.txt');
nGM = length(GM);
ap = [1;1];
rg(:,1) = 1*GM(1:nGM);
ag = ap*rg';

%% Ĳַ˶
deltt = 0.005;
keq0=m+deltt*c/2;

keq = keq0;
invkeq = inv(keq);

n = nGM;
dof = 2;

d_1 = zeros(dof,1);
d0 = zeros(dof,1);
v0 = zeros(dof,1);
a0 = zeros(dof,1);

d1 = zeros(dof,1);
a1=inv(m+deltt*c/2)*(-m*ag(:,1)-c*(d1-d_1)/deltt);
v1=(d1-d0)/deltt+deltt*a1/2;
d(:,1)=d1;
v(:,1)=v1;
a(:,1)=a1;

niter = 0;
for i=2:n
    % new step
	d_1 = d0;
	d0 = d1;
	v0 = v1;
	a0 = a1;
	
	d1 = d_1+2*deltt*v0;
	% predict
    a1 = a0;
	v1 = (d_1-d0)/deltt+2*v0+deltt*a1/2;
	
    fs1 = zeros(dof,1);
    fs2 = zeros(dof,1);
    fs1(1,1) = kE*d0(1)/2;
    fs2(1:2,1) = KN*d1;
    fs = fs1+fs2;
    % fs = k*d1;

	unforce0 = -m*ag(:,i)-m*a1-c*v1-fs;
    unforce(:,i) = unforce0;
     
    delta1 = invkeq*unforce0;
	a1 = a1+delta1;
	v1 = (d_1-d0)/deltt+2*v0+deltt*a1/2;

    d(:,i)=d1;
    v(:,i)=v1;
    a(:,i)=a1;
    f(:,i) = fs;
	f1(:,i) = fs1;
    f2(:,i) = fs2;
end


%% 
t=deltt:deltt:n*deltt;

% Displacement
Dis(:,1) = t;
for i=2:(dof+1)
    Dis(:,i) = d(i-1,:);
end
save ([dir,'\Displacement.txt'], 'Dis', '-ascii');
Disp1 = Dis(:,2);
save ([dir,'\Disp1.txt'], 'Disp1', '-ascii');

% Velocity
Vel(:,1) = t;
for i=2:(dof+1)
    Vel(:,i) = v(i-1,:);
end
save ([dir,'\Velocity.txt'], 'Vel', '-ascii');

% Acceleration
Acc(:,1) = t;
for i=2:(dof+1)
    Acc(:,i) = a(i-1,:);
end
save ([dir,'\Acceleration.txt'], 'Acc', '-ascii');

% Force
Force(:,1) = t;
for i=2:(dof+1)
    Force(:,i) = f(i-1,:);
end
save ([dir,'\Force.txt'], 'Force', '-ascii');

